katello-deploy devel - installing global rvm is causing troubles for puppet running under passenger
Description

As part of the devel install, global rvm is installed.  With the global rvm, passenger is unable to start up the puppet app.  The errors

generated can be seen in the logs below.  After some debugging, found that $LOAD_PATH is including a mix of ruby 1.8 and 1.9.3

paths; however, puppet currently runs under 1.8.

In order to address this, I performed the following on my configuration:

1. uninstalled global rvm

2. installed rvm locally within the foreman app

Scenario:

Execute the following from a host:

puppet agent --test

Logs:

> error_log <

[ 2014-04-23 11:46:06.0919 2049/7fcc0ea7f700 Pool2/Spawner.h:739 ]: [App 27792 stdout]

[ 2014-04-23 11:46:06.1782 2049/7fcc0ea7f700 Pool2/Implementation.cpp:774 ]: Could not spawn process for group

/etc/puppet/rack#default: An error occured while starting up the preloader.

in 'void

Passenger::ApplicationPool2::SmartSpawner::handleErrorResponse(Passenger::ApplicationPool2::SmartSpawner::StartupDetails&)'

(SmartSpawner.h:455)

in 'std::string

Passenger::ApplicationPool2::SmartSpawner::negotiatePreloaderStartup(Passenger::ApplicationPool2::SmartSpawner::StartupDetail

s&)' (SmartSpawner.h:558)

in 'void Passenger::ApplicationPool2::SmartSpawner::startPreloader()' (SmartSpawner.h:206)

in 'virtual Passenger::ApplicationPool2::ProcessPtr Passenger::ApplicationPool2::SmartSpawner::spawn(const

Passenger::ApplicationPool2::Options&)' (SmartSpawner.h:744)

in 'void Passenger::ApplicationPool2::Group::spawnThreadRealMain(const Passenger::ApplicationPool2::SpawnerPtr&, const

Passenger::ApplicationPool2::Options&, unsigned int)' (Implementation.cpp:707)

[ 2014-04-23 11:46:06.1783 2049/7fcc0f480700 agents/HelperAgent/RequestHandler.h:1889 ]: [Client 20] Cannot checkout session.

An error occured while starting up the preloader.

Error page:

no such file to load -- rack (LoadError)

/usr/lib/ruby/site_ruby/1.8/rubygems/custom_require.rb:31:in `gem_original_require'

/usr/lib/ruby/site_ruby/1.8/rubygems/custom_require.rb:31:in `require'

/usr/lib/ruby/gems/1.8/gems/passenger-4.0.5/helper-scripts/rack-preloader.rb:77:in `preload_app'

/usr/lib/ruby/gems/1.8/gems/passenger-4.0.5/helper-scripts/rack-preloader.rb:127

> puppet_access_ssl.log <

192.168.122.181 - - [23/Apr/2014:11:46:06 0400] "GET /KT_ACME_Corporation_Library_os_view_4/certificate/ca? HTTP/1.1" 500

23120 "" "-"

Associated revisions

Revision 10f7e1a9 - 04/30/2014 06:42 AM - Eric D Helms 

Fixes #5467, #5494: Removes reliance on external RVM module and switches to single user install.
Removes the reliance on an external RVM module to allow installation as

the devel deployment user. Switches to using the 'vcsrepo' puppet module

to alleviate issues with switching directories when cloning. Lastly,

adds user creation and sets the user password to 'changeme' for all

devel deployments.

Revision 2ffe9d43 - 04/30/2014 01:17 PM - Eric Helms

Merge pull request #5 from ehelms/fixes-5467

Fixes #5467, #5494: Removes reliance on external RVM module and switches...

History

#1 - 06/04/2014 03:41 PM - Eric Helms

- Status changed from New to Closed

- Triaged changed from No to Yes

The devel puppet module has been updated to install RVM for the user and no longer globally.

#2 - 08/22/2014 08:05 AM - Eric Helms

- translation missing: en.field_release set to 13
